#ifndef _GOST_H_
#define _GOST_H_

#ifdef __cplusplus
extern "C" {
#endif

/* plain block ciphering (aka ECB mode) */
void _System GOST_blockencrypt(unsigned char const in[8], unsigned char out[8], unsigned char const key[32]);
void _System GOST_blockdecrypt(unsigned char const in[8], unsigned char out[8], unsigned char const key[32]);

/* ciphering in OFB mode */
void _System GOST_ofbencrypt(unsigned char const *in, unsigned char *out, int len, unsigned char iv[8], int *num, unsigned char const key[32]);
void _System GOST_ofbdecrypt(unsigned char const *in, unsigned char *out, int len, unsigned char iv[8], int *num, unsigned char const key[32]);

/* ciphering in CFB mode */
void _System GOST_cfbencrypt(unsigned char const *in, unsigned char *out, int len, unsigned char iv[8], int *num, unsigned char const key[32]);
void _System GOST_cfbdecrypt(unsigned char const *in, unsigned char *out, int len, unsigned char iv[8], int *num, unsigned char const key[32]);

/* ciphering in CBC mode */
void _System GOST_cbcencrypt(unsigned char const *in, unsigned char *out, int len, unsigned char iv[8], unsigned char const key[32]);
void _System GOST_cbcdecrypt(unsigned char const *in, unsigned char *out, int len, unsigned char iv[8], unsigned char const key[32]);

/* message signing */
void _System GOST_mac(unsigned char const *in, int len, unsigned char out[8], unsigned char const key[32]);

/* Gost hash function */
void _System GOST_hashupdate(const unsigned char * in, int len, unsigned char ctx[132]);
void _System GOST_hashfinal(unsigned char digest[32], unsigned char ctx[132]);

#ifdef __cplusplus
}
#endif

#endif /* _GOST_H_ */